#include <stdio.h>
#include "trans_ini.H"

#define E_CREATION_SOL 1
#define E_MEMOIRE_SOL 2
#define E_INDICE_ARBRE 3
#define E_EXISTE_ARBRE 4

class trans_sol
{
	private:
	int n;
	arbre_p **liste;

	public:
	trans_sol(int _n);

	int taille();
	void definir(int k,arbre_p *arbre);
	arbre_p *donner(int k);

	private:
	void erreur(int k);
};

trans_sol :: trans_sol(int _n)
{
	int k;

	if (_n < 0)
		erreur(E_CREATION_SOL);

	n = _n;
	
	if (!(liste = (arbre_p **) calloc(n,sizeof(arbre_p *))))
		erreur(E_MEMOIRE_SOL);

	for(k = 0;k < n;k++)
		liste[k] = NULL;
}

void trans_sol :: definir(int k,arbre_p *a)
{
	if ((k < 0) || (k >= n))
		erreur(E_INDICE_ARBRE);

	liste[k] = a;
}

arbre_p *trans_sol :: donner(int k)
{
	if ((k < 0) || (k >= n))
		erreur(E_INDICE_ARBRE);

	if (!liste[k])
		erreur(E_EXISTE_ARBRE);

	return(liste[k]);
}

void trans_sol :: erreur(int k)
{
	switch(k)
	{
		case E_CREATION_SOL: printf("Erreur : nombre d'arbre\n"); break;
		case E_MEMOIRE_SOL: printf("Erreur : allocation memoire pour trans_sol\n"); break;
		case E_INDICE_ARBRE: printf("Erreur : indice d'arbre incorrecte\n"); break;
		case E_EXISTE_ARBRE: printf("Erreur : arbre inexistant\n"); break;
	}
	exit(0);
}
